<?php
/**
 * Top X Stats (topxstats_)
 *
 * @file ./topxstats_source/main.php
 * @author Labradoodle-360 <creativewebdsign@gmail.com>
 * @copyright Matthew Kerle, 2013
 *
 * @version 1.0.1
 */

if (!defined('SMF'))
	die('Hacking attempt...');


function topXStats_construct($call_template = false)
{
	global $topxstats, $modSettings;
	if ($call_template == true)
	{
		loadTemplate('topxstats_templates/main', array('topxstats_css/main'));
		return true;
	}
	$topxstats = array(
		'enabled' => !empty($modSettings['topxstats_index']) ? true : false,
		'num_stats' => !empty($modSettings['topxstats_count']) ? (int) $modSettings['topxstats_count'] : 0,
		'group_colors' => !empty($modSettings['topxstats_group_colors']) ? true : false
	);
	topXStatsInitialize();
}

function topXStatsInitialize()
{
	global $topxstats;
	if (!isset($_GET['xml']) && !isset($_GET['action']) && !isset($_GET['topic']) && !isset($_GET['board']) && $topxstats['enabled'] === true)
	{
		global $sourcedir, $txt, $context;
		if (empty($topxstats['num_stats']))
			$topxstats['num_stats'] = 5;
		require_once($sourcedir . '/topxstats_source/resources/main_requests.php');
		loadLanguage('topxstats_languages/main');
		$getFuncs = array('latest_members', 'latest_posts', 'top_posters');
		foreach ($getFuncs as $key => $value)
		{
			$cache_ttl = 2 * 60;
			if (cache_get_data('topxstats_' . $value, $cache_ttl) != null)
				$topxstats[$value] = cache_get_data('topxstats_' . $value, $cache_ttl);
			else
			{
				$topxstats[$value] = call_user_func('topxstats_' . $value, $topxstats['num_stats'], $topxstats['group_colors']);
				cache_put_data('topxstats_' . $value, $topxstats[$value], $cache_ttl);
			}
		}
		$topxstats += array(
			'final_count' => topxstats_stats_sum($topxstats['latest_members'], $topxstats['latest_posts'], $topxstats['top_posters']),
			'forum_name' => &$context['forum_name'],
			'txt' => &$txt['topxstats']
		);
		loadSubTemplate('topxstats_integrate', true);
	}
}