<?php
/**
 * Top X Stats (topxstats_)
 *
 * @file ./topxstats_script.php
 * @author Labradoodle-360 <creativewebdsign@gmail.com>
 * @copyright Matthew Kerle, 2013
 *
 * @version 1.0.1
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	die('<strong>Error:</strong> Cannot install - please make sure that this file in the same directory as SMF\'s SSI.php file.');

global $context;
$action = !empty($context['uninstalling']) ? 'remove' : 'add';
$call_funcs = array('Hooks', 'Settings');
foreach ($call_funcs as $key => $value)
	call_user_func('process' . $value, $action);

function processHooks($action)
{
	$hooks = array(
		'integrate_pre_include' => array(
			'$sourcedir/topxstats_source/resources/hooks.php'
		),
		'integrate_admin_areas' => array(
			'topXStats_hook_adminArea'
		),
		'integrate_modify_modifications' => array(
			'topXStats_hook_subAction'
		)
	);
	foreach ($hooks as $key => $value)
	{
		if (is_array($hooks[$key]))
		{
			foreach ($hooks[$key] as $sValue)
			{
				if ($action == 'add')
					call_user_func($action . '_integration_function', $key, $sValue, true);
				else
					call_user_func($action . '_integration_function', $key, $sValue);
			}
		}
		else
		{
			if ($action == 'add')
				call_user_func($action . '_integration_function', $key, $value, true);
			else
				call_user_func($action . '_integration_function', $key, $value);
		}
	}
}

function processSettings($action)
{
	$final_variables = array( 'topxstats_index', 'topxstats_count', 'topxstats_group_colors' );
	if ($action == 'add')
	{
		$final_values = array( 1, 5, 1 );
		foreach ($final_variables as $key => $value)
			$final_array[$value] = $final_values[$key];
		updateSettings($final_array);
		reloadSettings();
	}
	else
	{
		global $smcFunc;
		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}settings
			WHERE variable IN ({array_string:final_variables})',
			array(
				'final_variables' => $final_variables
			)
		);
	}
}

if (SMF == 'SSI')
	echo 'Modification Script Successfully Completed!';